config/routes.rb
Rails.application.routes.draw do
  resources :images
  devise_for :users
  root 'welcome#index'
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/image.rb
class Image < ApplicationRecord
  validates :name, presence: true
  validates :picture, presence: true
  belongs_to :user
  mount_uploader :picture, PictureUploader
  validate :picture_size

  def get_user_email
    user.email
  end

  private

  def picture_size
    errors.add(:picture, "should be less than 4MB") if picture.size > 4.megabytes
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable, :confirmable,
         :recoverable, :rememberable, :validatable, :trackable

  has_many :images
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
end

app/controllers/images_controller.rb
class ImagesController < ApplicationController
  before_action :set_image, only: [:show, :edit, :update, :destroy]

  # GET /images
  # GET /images.json
  def index
    @images = Image.all
  end

  # GET /images/1
  # GET /images/1.json
  def show
  end

  # GET /images/new
  def new
    @image = Image.new
  end

  # GET /images/1/edit
  def edit
  end

  # POST /images
  # POST /images.json
  def create
    @image = current_user.images.new(image_params)

    respond_to do |format|
      if @image.save
        format.html { redirect_to @image, notice: 'Image was successfully created.' }
        format.json { render :show, status: :created, location: @image }
      else
        format.html { render :new }
        format.json { render json: @image.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /images/1
  # PATCH/PUT /images/1.json
  def update
    respond_to do |format|
      if @image.update(image_params)
        format.html { redirect_to @image, notice: 'Image was successfully updated.' }
        format.json { render :show, status: :ok, location: @image }
      else
        format.html { render :edit }
        format.json { render json: @image.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /images/1
  # DELETE /images/1.json
  def destroy
    @image.destroy
    respond_to do |format|
      format.html { redirect_to images_url, notice: 'Image was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_image
      @image = Image.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def image_params
      params.require(:image).permit(:name, :picture)
    end
end

app/controllers/welcome_controller.rb
class WelcomeController < ApplicationController
  skip_before_action :authenticate_user!, only: [:index]

  def index
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/images/_form.html.erb
<%= form_with(model: image, local: true, multipart: true) do |form| %>
  <% if image.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(image.errors.count, "error") %> prohibited this image from being saved:</h2>

      <ul>
        <% image.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :picture %>
    <%= form.file_field :picture, accept: 'image/jpg, image/jpeg, image/png' %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

<%= javascript_pack_tag 'image_form' %>

app/views/images/edit.html.erb
<h1>Editing Image</h1>

<%= render 'form', image: @image %>

<%= link_to 'Show', @image %> |
<%= link_to 'Back', images_path %>

app/views/images/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Images</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Picture</th>
      <th>User</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @images.each do |image| %>
      <tr>
        <td><%= image.name %></td>
        <td><%= image_tag(image.picture.url, size: '100x100') if image.picture? %></td>
        <td><%= image.get_user_email %></td>
        <td><%= link_to 'Show', image %></td>
        <td><%= link_to 'Edit', edit_image_path(image) %></td>
        <td><%= link_to 'Destroy', image, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Image', new_image_path %>

app/views/images/new.html.erb
<h1>New Image</h1>

<%= render 'form', image: @image %>

<%= link_to 'Back', images_path %>

app/views/images/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @image.name %>
</p>

<p>
  <strong>User:</strong>
  <%= @image.get_user_email %>
</p>

<p>
  <strong></strong>
  <%= image_tag(@image.picture.url, size: "300x300") if @image.picture? %>
</p>

<%= link_to 'Edit', edit_image_path(@image) %> |
<%= link_to 'Back', images_path %>

app/views/layouts/_flash_messages.html.erb
<div class="container">
  <% flash.each do |name, message| %>
    <% klass = "alert-success" %>
    <% klass = "alert-danger" if name == 'alert' %>
    <div class="alert <%= klass %> alert-dismissible fade show" role="alert">
      <%= message %>
      <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
  <% end %>
</div>

app/views/layouts/_navigation.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <div class="container">
    <a class="navbar-brand" href="#">Photo++</a>
      <% if current_user %>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>

      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
          <li class="nav-item active">
            <a class="nav-link" href="#">Home <span class="sr-only">(current)</span></a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="#">Link</a>
          </li>
          <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              Dropdown
            </a>
            <div class="dropdown-menu" aria-labelledby="navbarDropdown">
              <a class="dropdown-item" href="#">Action</a>
              <a class="dropdown-item" href="#">Another action</a>
              <div class="dropdown-divider"></div>
              <a class="dropdown-item" href="#">Something else here</a>
            </div>
          </li>
          <li class="nav-item">
            <a class="nav-link disabled" href="#" tabindex="-1" aria-disabled="true">Disabled</a>
          </li>
        </ul>
        <form class="form-inline my-2 my-lg-0">
          <%= fa_icon 'user' %><%= current_user.email %>
          <%= link_to 'Log out', destroy_user_session_path, class: "btn btn-outline-danger ml-3 my-sm-0", method: :delete %>
        </form>
      </div>
    <% end %>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>PhotoPlusPlus</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <div class="container">
      <%= render 'layouts/flash_messages' %>
      <%= yield %>
    </div>
  </body>
</html>

app/views/welcome/index.html.erb
<div class="jumbotron">
  <h1 class="display-4 text-center text-white">Photo++ application</h1>
  <p class="lead text-white">This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>
  <hr class="my-4">
  <p class="text-white">It uses utility classes for typography and spacing to space content out within the larger container.</p>
  <%= link_to 'Sign up', new_user_registration_path, class: "btn btn-outline-success btn-lg" %>
</div>